package org.jboss.rtgov.elasticsearch;

import org.overlord.rtgov.activity.model.ActivityType;
import org.overlord.rtgov.ep.EventProcessor;

import java.io.Serializable;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 13/11/13
 * Time: 22:48
 *Processor sets the time the event was processed
 * MessageReceived
 */
public class AcceptTimeStampProcessor extends EventProcessor {
    /**
     * This method returns the current date/time.
     *
     * @return The timestamp
     */
    protected long getTimestamp() {
        return (System.currentTimeMillis());
    }



    @Override
    public Serializable process(String source, Serializable event, int retriesLeft) throws Exception {
        if(event instanceof ActivityType){
            ((ActivityType) event).setTimestamp(getTimestamp());
             return  event;
        }
        return null;
    }
}
