package org.jboss.rtgov.elasticsearch.actvity;

import org.overlord.rtgov.activity.model.ActivityTypeId;
import org.overlord.rtgov.activity.model.soa.RequestReceived;
import org.overlord.rtgov.activity.model.soa.ResponseSent;
import org.overlord.rtgov.analytics.service.ResponseTime;
import org.overlord.rtgov.analytics.situation.Situation;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 18/11/13
 * Time: 22:13
 * To change this template use File | Settings | File Templates.
 */
public class Util {
    public static ResponseTime createResponseTime(RequestReceived req, ResponseSent responseSent) {
        ResponseTime rt = new ResponseTime();
        ;
        rt.setRequestId(ActivityTypeId.createId(req));
        rt.setResponseId(ActivityTypeId.createId(responseSent));
        rt.setServiceType(req.getServiceType());
        rt.setInterface(req.getInterface());
        rt.setOperation(req.getOperation());
        rt.setFault(responseSent.getFault());
        rt.setProperties(req.getProperties());
        // todo set the context for the response time object
        //  rt.setContext(req.getContext());
        long responseTime = responseSent.getTimestamp() - req.getTimestamp();
        rt.setAverage(responseTime);
        return rt;
    }

    public static Situation createSituation(ResponseTime rt) {
        Situation situation = new Situation();

        situation.setType("SLA Violation");
    //    situation.setSubject(Situation.createSubject(rt.getInterface(), rt.getServiceType(),
        situation.setSubject(Situation.createSubject(rt.getInterface()));
        situation.setTimestamp(System.currentTimeMillis());
        situation.getProperties().putAll(rt.getProperties());

        if (rt.getRequestId() != null) {
            situation.getActivityTypeIds().add(rt.getRequestId());
        }
        if (rt.getResponseId() != null) {
            situation.getActivityTypeIds().add(rt.getResponseId());
        }

        situation.getContext().addAll(rt.getContext());

        String serviceName = rt.getServiceType();

        if (serviceName.startsWith("{")) {
            serviceName = javax.xml.namespace.QName.valueOf(serviceName).getLocalPart();
        }
        return situation;

    }
}
