package org.jboss.rtgov.elasticsearch.repo.elastic;

import org.codehaus.jackson.map.ObjectMapper;
import org.jboss.resteasy.client.ClientResponse;
import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.plugins.providers.RegisterBuiltin;
import org.jboss.resteasy.spi.ResteasyProviderFactory;
import org.jboss.rtgov.elasticsearch.actvity.ElasticActivityUnit;
import org.jboss.rtgov.elasticsearch.repo.ElasticSearchException;
import org.jboss.rtgov.elasticsearch.repo.elastic.impl.rest.ActivityRest;
import org.overlord.rtgov.activity.model.ActivityType;
import org.overlord.rtgov.activity.model.Context;
import org.overlord.rtgov.activity.model.soa.RPCActivityType;
import org.overlord.rtgov.activity.util.ActivityUtil;
import org.overlord.rtgov.common.service.Service;

import java.io.IOException;
import java.util.logging.Logger;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 13/11/13
 * Time: 22:51
 *todo : create situation when no conversation id is defined.
 */
@Deprecated
public class ActivityElasticRepo extends Service implements ActivityRepo {
    Logger logger = Logger.getLogger(ActivityElasticRepo.class.getName());
    protected ObjectMapper MAPPER = null;

    private ActivityRest client;

    @Override
    public void init() throws Exception {
        super.init();
        MAPPER = new ObjectMapper();

        try {
            // this initialization only needs to be done once per VM


            RegisterBuiltin.register(ResteasyProviderFactory.getInstance());
            client = ProxyFactory.create(ActivityRest.class, "http://localhost:9200");
        } catch (Exception e) {
            throw new ElasticSearchException(e.toString(), e);
        }
    }


    private String getConversationID(ActivityType name) throws ElasticSearchException {
        String conversationid = null;
        for (Context context : name.getContext()) {
            if (context.getType() == Context.Type.Endpoint) {
                System.out.println(" endpoint " + context.getValue());
                break;
            }
            if (context.getType() == Context.Type.Conversation) {
                System.out.println(" conversation " + context.getValue());
                conversationid = context.getValue();
                break;
            }

        }
        if (conversationid == null)
            throw new ElasticSearchException("No Conversation id for Actvity " + name.toString());
        return conversationid;
    }


    private void doSend(String service,

                        String id,
                        String body) throws ElasticSearchException {

        System.out.println("Service=" + service +  ", id=" + id);
        ClientResponse t = client.persistEvent(service.toLowerCase(), id.toLowerCase(), body);

        //Any REST Resource which returns a ClientResponse, has to call releaseConnection to release all the connections back
//to the connection pool
        if (t.getStatus() != 200 &&  t.getStatus() != 201)     {
            t.releaseConnection();

            throw new ElasticSearchException("Could not save ElasticActivityUnit[Service=" + service + ", id=" + id + "], Reason [" + t.toString() + "] ");
        }
        t.releaseConnection();

    }

    private void doSend(String service,
                        String id,
                        ElasticActivityUnit eau) throws ElasticSearchException {

        System.out.println("Service=" + service + ", id=" + id);
        ClientResponse t = client.saveElasticActivityUnit(service.toLowerCase(), id.toLowerCase(), eau);
        if (t.getStatus() != 200 &&  t.getStatus() != 201){
            t.releaseConnection();

        throw new ElasticSearchException("Could not save ElasticActivityUnit[Service=" + service + ", id=" + id + "], Reason [" + t.toString() + "] ");
        }
        t.releaseConnection();


    }


    // public RPCActivityType getActivityType(RPCActivityType act) throws ElasticSearchException {
    // try {
    // return MAPPER.readValue(getActvityDocument(act),act.getClass());
    //       return client.getDocument("/"+act.getInterface().toLowerCase()+"/"+act.getInterface().toLowerCase()+"/"+getConversationID(act).toLowerCase()+"/_source");
    // } catch (IOException e) {
    //   e.printStackTrace();
    // throw new ElasticSearchException("Could not deserialize Actvity Type "+act.toString(),e);
    // }
    // }
    private String getActvityDocument(RPCActivityType act) throws ElasticSearchException {

        logger.info("" + act.getInterface().toLowerCase() + "/" + act.getInterface().toLowerCase() + "/" + getConversationID(act).toLowerCase() + "/_source");
        ClientResponse<String> ttt = null;
        String result = ttt.getEntity();
        ttt.releaseConnection();
        return result;
    }

    public void saveActivityType(ElasticActivityUnit eau) throws ElasticSearchException {
        String au = null;
        try {
             au = ActivityUtil.objectToJSONString(eau);
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

        doSend(eau.getInterfaceName(), eau.getConversationID(), au);

    }

    public ElasticActivityUnit getElasticActivityUnit(ElasticActivityUnit eau) throws ElasticSearchException {
        ClientResponse<String> result = client.getElasticActivityUnit(eau.getInterfaceName().toLowerCase(), eau.getConversationID().toLowerCase() + "/_source");
        if (result.getStatus() != 200){
            result.releaseConnection() ;
            throw new ElasticSearchException("Could not get ElasticActivityUnit[Service=" + eau.getInterfaceName() + ", id=" + eau.getConversationID() + "], Reason [" + result.toString() + "] ");
        }
        try {
            eau = MAPPER.readValue(result.getEntity(),ElasticActivityUnit.class);
        } catch (IOException e) {
            result.releaseConnection() ;
           throw   new ElasticSearchException("Could not get ElasticActivityUnit[Service=" + eau.getInterfaceName() + ", id=" + eau.getConversationID() + "], Reason [" + result.toString() + "] ");
        }
        result.releaseConnection();
        return eau;
    }

    public ElasticActivityUnit getElasticActivityUnit(String service, String id) throws ElasticSearchException {
        ClientResponse<String> result = client.getElasticActivityUnit(service.toLowerCase(), id.toLowerCase() + "/_source");
        if (result.getStatus() != 200) {
            result.releaseConnection();

            throw new ElasticSearchException("Could not get ElasticActivityUnit[Service=" + service.toLowerCase() + ", id=" + id.toLowerCase() + "], Reason [" + result.toString() + "] ");
        }
        ElasticActivityUnit eau;
        try {
            eau = MAPPER.readValue(result.getEntity(),ElasticActivityUnit.class);
        } catch (IOException e) {
            result.releaseConnection() ;
            throw   new ElasticSearchException("Could not get ElasticActivityUnit[Service=" + service + ", id=" + id + "], Reason [" + result.toString() + "] ");
        }
        result.releaseConnection();
        return eau;
    }


    //MAPPER.readValue(temp, RPCActivityType.class);
}
