package org.jboss.rtgov.elasticsearch.repo.elastic.impl.rest;

import org.codehaus.jackson.map.ObjectMapper;
import org.jboss.resteasy.client.ClientResponse;
import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.plugins.providers.RegisterBuiltin;
import org.jboss.resteasy.spi.ResteasyProviderFactory;
import org.jboss.rtgov.elasticsearch.repo.ElasticSearchException;
import org.jboss.rtgov.elasticsearch.repo.elastic.AbstractElasticRepo2;
import org.overlord.rtgov.activity.util.ActivityUtil;

import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 03/02/14
 * Time: 22:02
 */
//todo change repo impl to use the java api instead of rest.
    // use api to setup any relationships that are required
public class BasicElasticRestRepo extends AbstractElasticRepo2<String,Serializable>  {
    Logger logger = Logger.getLogger(BasicElasticRestRepo.class.getName());

    protected BasicElasticSearchRest client;


    @Override
    public void init() throws Exception {
        super.init();

        MAPPER = new ObjectMapper();

        try {
            // this initialization only needs to be done once per VM
            RegisterBuiltin.register(ResteasyProviderFactory.getInstance());
            client = ProxyFactory.create(BasicElasticSearchRest.class, ELASTIC_UL);
        } catch (Exception e) {
            throw new ElasticSearchException(e.toString(), e);
        }
    }



    @Override
    public void persist(Serializable document, String id) throws ElasticSearchException {
        logger.info("[/"+index+"/"+type+"] Attempting to persist document of Type [" + document.getClass().getName() + "] with id [" + id + "]");

        if (id != null) {

            ClientResponse<String> cr = client.persistEvent(index, type, id, convertTypeToJson(document));
            if (cr.getStatus() != 200 && cr.getStatus() != 201) {
                ElasticSearchException e = new ElasticSearchException("Could persist Activity with parent data [" + document.toString() + "], Entity returned : " + cr.getEntity());
                cr.releaseConnection();
                logger.log(Level.WARNING, " Persist was not successful for Type [" + document.getClass().getName() + "] with id [" + id + "]");

                throw e;
            }
            cr.releaseConnection();
        } else {
            logger.log(Level.WARNING, "NO id defined. Cannot persist ActivityUnit");
            ElasticSearchException e = new ElasticSearchException("NO id defined. Cannot persist ActivityUnit[ " + document.toString() + "]");
            throw e;
        }
    }


    @Override
    public void remove(Serializable document, String id) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

}
