package org.jboss.rtgov.elasticsearch.repo.elastic.impl.rest;

import org.jboss.resteasy.client.ClientResponse;
import org.jboss.rtgov.elasticsearch.repo.ElasticSearchException;
import org.overlord.rtgov.analytics.situation.Situation;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 19/11/13
 * Time: 09:56
 * // how to get Parent with child
 * curl 'localhost:9200/indexname/childname/_search' -d '{
 * fields:["_parent", "_source"]
 * }'
 * <p/>
 * // todo  how to filter Contracts with children situations
 * curl -XPOST http://localhost:9200/documents/document/_search -d '{
 * "query": {
 * "match": {
 * "title": "papam"
 * }
 * },
 * "filter": {
 * "has_child": {
 * "type": "comment",
 * "query" : {
 * "match": {
 * "author": {
 * "query" : "John Doe",
 * "operator" : "and"
 * }
 * }
 * }
 * }
 * }
 * }'
 */
//TODO need to define UI which displays only the requests that have sistuation associated with them. This has_child queury
//TODO. IMPORTANT:_ DO FIRST : ******** need to update the siutation  mapping to reference the properties properties.Conversation as its routing value
@Deprecated
public class SituationElasticRestRepo extends AbstractElasticRestRepo<String, Situation, SituationRest> {
    Logger logger = Logger.getLogger(SituationElasticRestRepo.class.getName());

    private static String parent_childRelation2 = "{\"situation\": {\n" +
            "    \"_parent\": {\n" +
            "        \"type\": \"contracthandlervb\"\n" +
            "    },\n" +
            "    \"_routing\": {\n" +
            "        \"required\": true,\n" +
            "        \"path\": \"_id\"\n" +
            "    }\n" +
            "}}";
    private static String parent_childRelation = "{\"situation\": {\n" +
            "    \"_parent\": {\n" +
            "        \"type\": \""+ELASTIC_ACTIVITY_TYPE+"\"\n" +
            "    },\n" +
            "    \"_routing\": {\n" +
            "        \"required\": true,\n" +
            "        \"path\": \"properties.Conversation\"\n" +
            "    }\n" +
            "}}";

    @Override
    public void init() throws Exception {
        super.init();


    }
     //TODO there should be some check here to see if the mapping already exist. It sub optimal to do this http call every time
    private void setupParentMapping(String  index) throws ElasticSearchException {
        logger.info("Setting up elastic search Situation/Contract parent child mapping ");
        ClientResponse<String> cr2 = client.create(index.toLowerCase(), "_mapping", parent_childRelation);
        if (cr2.getStatus() != 200 && cr2.getStatus() != 201) {
            logger.log(Level.SEVERE, "Setting up elastic search Situation/Contract parent child mapping ");

            ElasticSearchException e = new ElasticSearchException("Could not initialize mapping for situation obj" + cr2.getEntity());
            cr2.releaseConnection();

            throw e;
        }
        cr2.releaseConnection();
    }

    public void persist(Situation document) throws ElasticSearchException {

        String parent_id = (String) document.getProperties().get("Conversation");
        setupParentMapping(document.getSubject().toLowerCase());

        if (parent_id != null) {
            // adding a link to the event which cause this issue
            document.getProperties().put("Activity Unit with issue ", ELASTIC_UL + "/" + document.getSubject().toLowerCase() + "/" +ELASTIC_ACTIVITY_TYPE+ "/" + parent_id + "?pretty=true"
            );
            ClientResponse<String> cr = client.create(document.getSubject().toLowerCase(),
                    parent_id,
                    convertTypeToJson(document),
                    (String) document.getProperties().get("Conversation"));
            if (cr.getStatus() != 200 && cr.getStatus() != 201) {
                ElasticSearchException e = new ElasticSearchException("Could persist Situation with parent data [" + document.toString() + "], Entity returned : " + cr.getEntity());
                cr.releaseConnection();

                throw e;
            }
            cr.releaseConnection();
        } else {
            ClientResponse<String> cr = client.create(document.getSubject().toLowerCase(), document.getId().toLowerCase(), convertTypeToJson(document));
            if (cr.getStatus() != 200 && cr.getStatus() != 201) {
                ElasticSearchException e = new ElasticSearchException("Could persist Situation [" + document.toString() + "], Entity returned : " + cr.getEntity());
                cr.releaseConnection();

                throw e;
            }
            cr.releaseConnection();
        }

    }

    public void remove(Situation document) {

    }

    @Override
    protected Class<SituationRest> getRestClientClassImpl() {
        return SituationRest.class;
    }


    @Override
    public void persist(Situation document, String id) throws ElasticSearchException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    public void remove(Situation document, String id) {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
